<?php
/**
 * @author Thomas Tanghus
 * @copyright 2013-2014 Thomas Tanghus (thomas@tanghus.net)
 *
 * This file is licensed under the Affero General Public License version 3 or
 * later.
 * See the COPYING-README file.
 */

namespace OCA\Media;

use Sabre\VObject,
	OCP\AppFramework,
	OCA\Contacts\Controller\SettingsController;

/**
 * This class manages our app actions
 *
 * TODO: Merge in Dispatcher
 */
App::$l10n = \OC_L10N::get('media');

class App {

	/**
	* @brief Categories of the user
	* @var OC_VCategories
	*/
	public static $categories = null;

	/**
	 * @brief language object for calendar app
	 *
	 * @var OC_L10N
	 */
	public static $l10n;

	/**
	* If backends are added to this map, they will be automatically mapped
	* to their respective classes, if constructed with the 'getBackend' method.
	*
	* @var array
	*/
	public static $backendClasses = array(
		/*
		'local' => 'OCA\Media\Backend\Database',
		'shared' => 'OCA\Media\Backend\Shared',
		*/
	);

	public function __construct(
		$user = null,
		$backendsTableName = '*PREFIX*addressbooks_backend',
		$dbBackend = null
	) {
		/*
		$this->user = $user ? $user : \OCP\User::getUser();
		$this->backendsTableName = $backendsTableName;
		$this->dbBackend = $dbBackend
			? $dbBackend
			: new Backend\Database($user);
		}
		*/
	}

	/**
	* Gets backend by name.
	*
	* @param string $name
	* @return \Backend\AbstractBackend
	*/
	public function getBackend($name) {
		$name = $name ? $name : 'local';
		if (isset(self::$backendClasses[$name])) {
			return new self::$backendClasses[$name]($this->user);
		} else {
			throw new \Exception('No backend for: ' . $name, '404');
		}
	}

}
